//Meze je portreba nastavit v kodu, serialni komunikace moc nefunguje. Jinak je ale eeprom plne funkcni
//no a ted se mi to pred koncem uplne cele seklo
//na yacatku tvra asi 5s nez nabootuje

#include <Wire.h>
#include "TM1636.h"
#include "Math.h"
#include <EEPROM.h>



#define btnDW 9 //down
#define btnUP 10 //up
#define btnMN 11 //menu

#define led1 2
#define led2 3
#define led3 4
#define led4 5

#define buzz 6

#define temp_pin A0
#define light_pin A1

TM1636 tm(7, 8);

String input = "";
boolean stringComplete = false;

int MEZ_MAX = 27;//horni mez
int MEZ_MIN = 25;//dolni mez

unsigned long oldMillis, oldMillisLED, oldMillisBuzz;// pomocne promenne pro millis fce

int8_t dispdata[4] = {13, 13, 13, 13}; //chybove znaky
int8_t dispNONE[4] = {12, 12, 12, 12}; //prazdne znaky pro displej

double Temp;
int light, CELSI, FARAN, page;
float temp;
int trashold = 500; //spinaci hladina zatmeni (kdy jsou a nejsou otevrene dvere)
bool doorOpen, OLDdoorOpen; //pokud jsou dvere otevrene
bool ledState = false, buzzState = false, point = false;

bool btnUP_state, btnDW_state, btnMN_state;

bool ON;//pomocna pro blikani ledek - alarm

String MAXCtime, MAXFtime, MINCtime, MINFtime;

uint8_t minutes, hours, seconds, diw, day, month, year, readptr, oldsec, stat;
String day_table[7] = {"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"};
#define RTC_ADDR 0x68
byte rtcData[7] = {0, 0, 0, 0, 0, 0, 0};//pole pro data z rtc

byte dec2bcd(byte in) { //prevod mezi dec a bdc soustavou
  return ( (in / 10 * 16) + (in % 10) );
}
byte bcd2dec(byte in) {
  return ( (in / 16 * 10) + (in % 16) );
}




void setup() {
  input.reserve(200);
  Serial.begin(115200);//seriova rychlost
  DDRD |= 0b01111100;
  Wire.begin();


  pinMode(btnDW, INPUT_PULLUP);//vnitrni pullup rezistory v arduinu
  pinMode(btnUP, INPUT_PULLUP);
  pinMode(btnMN, INPUT_PULLUP);

  pinMode(led1, OUTPUT);
  pinMode(led2, OUTPUT);
  pinMode(led3, OUTPUT);
  pinMode(led4, OUTPUT);


  tm.init();//inicializace displeje
  tm.point(false);//nesviti casova dvojtecka
  tm.set(BRIGHTEST);//nejvyssi jas displeje

}

void loop() {
  readLight();//fce pro zjisteni svetla
  getTemp();//ziskani a pocitani teploty
  getTime();// ziskani casu
  getInput();
  maxmin();//zapisovani extremu

  allLedBlink();
  alarm();

  if (doorOpen) //pokud jsou dvere otevreny tak svitime, jinak je tma
  display7Seg();//zobrazeni na displeji
  else tm.display(dispNONE);


}

void maxmin() {


  if (CELSI > EEPROM.read(0)) {//maxc
    EEPROM.write(0, CELSI);
    MAXCtime =  String(2000 + year) + "-" + String(month) + "-" + String(day) + " " + String(hours) + ":" + String(minutes) + ":" + String(seconds);
  }

  if (FARAN > EEPROM.read(1)) { //maxf
    EEPROM.write(1, FARAN);
    MAXFtime =  String(2000 + year) + "-" + String(month) + "-" + String(day) + " " + String(hours) + ":" + String(minutes) + ":" + String(seconds);

  }

  if (CELSI < EEPROM.read(2)) {//minc
    EEPROM.write(2, CELSI);
    MINCtime =  String(2000 + year) + "-" + String(month) + "-" + String(day) + " " + String(hours) + ":" + String(minutes) + ":" + String(seconds);

  }

  if (FARAN < EEPROM.read(3)) {//minf
    EEPROM.write(3, FARAN);
    MINFtime =  String(2000 + year) + "-" + String(month) + "-" + String(day) + " " + String(hours) + ":" + String(minutes) + ":" + String(seconds);

  }

  if (!btnUP_state) {

    byte maximo = EEPROM.read(page);// zobraz maximum


    dispdata[0] = 12;//NONE
    dispdata[1] = maximo / 10;
    dispdata[2] = maximo % 10;
    dispdata[3] = 10 + page;
    tm.display(dispdata);
    delay(10000);//behem tohoto zobrazeni se stejne nemuze nic stat, takze tvrde zastaveni s fci delay nevadi

  }

  else if (!btnDW_state) {
    byte minimo = EEPROM.read(page + 2);  // zobraz minimum

    dispdata[0] = 12;//NONE - prazdny znak
    dispdata[1] = minimo / 10; //dostaneme desitky
    dispdata[2] = minimo % 10; //dostaneme jednotky
    dispdata[3] = 10 + page; //znak C nebo F
    tm.display(dispdata);//zobrazime

    delay(10000);//behem tohoto zobrazeni se stejne nemuze nic stat, takze tvrde zastaveni s fci delay nevadi
  }


  if (CELSI > MEZ_MAX) {
    ON = true;
    allLedBlink();
  } else
    ON = false;


  if (CELSI < MEZ_MIN) {
    ON = true;
    allLedBlink();
  }
  else
    ON = false;
  }

void getInput() {

  if (stringComplete) {
    Serial.println(input);


    // clear the string:
    input = "";
    stringComplete = false;
  }
}

void serialEvent() {
  while (Serial.available()) {
    // get the new byte:
    char inChar = (char)Serial.read();
    // add it to the inputString:
    input += inChar;
    // if the incoming character is a newline, set a flag
    // so the main loop can do something about it:
    if (inChar == '\n') {
      stringComplete = true;
    }
  }



  byte x;


  if (input == "maxc") {
    Serial.print(MAXCtime + " ");
    Serial.println(EEPROM.read(0) + "C");
  }

  if (input == "maxf") {
    Serial.print(MAXFtime + " ");
    Serial.println(EEPROM.read(1) + "F");
  }

  if (input == "delete") {
    EEPROM.write(0, 1);
    EEPROM.write(1, 1 );
    EEPROM.write(2, 99);
    EEPROM.write(3, 99);
    Serial.println("OK");
  }
  /*
    switch (x) {
      case 'c':
         break;

      case 'f':
        break;


      case 'c':
        Serial.println(MAXCtime + " " + EEPROM.read(0) + "C"); break;

      case 'f':
        Serial.println(MAXFtime + " " + EEPROM.read(1) + "F"); break;

    case 'd':


    }*/
  x = 'x';



}


void getTime() {
  // read from RTC

  Wire.beginTransmission(RTC_ADDR);
  Wire.write(0);
  Wire.endTransmission();
  Wire.requestFrom(RTC_ADDR, 7);
  for (uint8_t z = 0; z < 7; z++)
    rtcData[z] = Wire.read();

  // decode data
  seconds = bcd2dec(rtcData[0]);
  minutes = bcd2dec(rtcData[1]);
  hours = bcd2dec(rtcData[2]);
  diw = bcd2dec(rtcData[3]);
  day = bcd2dec(rtcData[4]);
  month = bcd2dec(rtcData[5]);
  year = bcd2dec(rtcData[6]);

  /*
    Serial.print(2000 + year);
    Serial.print("-");
    Serial.print(month);
    Serial.print("-");
    Serial.print(day);
    Serial.print(" ");
    Serial.print(hours);
    Serial.print(":");
    Serial.print(minutes);
    Serial.print(":");
    Serial.print(seconds);
    Serial.print(" ");
    Serial.println(CELSI);
    Serial.print("C");
  */





}

void getTemp() {


  Temp = log(10000.0 * ((1024.0 / analogRead(A0)) - 1));
  Temp = 1 / (0.001129148 + (0.000234125 * Temp) + (0.0000000876741 * Temp * Temp * Temp));
  CELSI = Temp - 273.15; //z kelvina na celsiuse
  FARAN = (CELSI * 9.0) / 5.0 + 32.0;
}

void display7Seg() {
  tm.display(dispdata);
  btnMN_state = digitalRead(btnMN);
  btnUP_state = digitalRead(btnUP);
  btnDW_state = digitalRead(btnDW);

  if (!btnMN_state)
    page++;

  if (page > 1)
    page = 0;

  switch (page)
  {
    case 0:
      dispdata[0] = 12;//NONE
      dispdata[1] = CELSI / 10;
      dispdata[2] = CELSI % 10;
      dispdata[3] = 10; //CELSI
      break;
    case 1:
      dispdata[0] = 12;//NONE
      dispdata[1] = FARAN / 10;
      dispdata[2] = FARAN % 10;
      dispdata[3] = 11;//FARAN
      break;
  }
}

void readLight() {
  light = analogRead(light_pin);
  OLDdoorOpen = doorOpen;//saving old door open state for alarm

  if (light > trashold)
    doorOpen = true;
  else doorOpen = false;

  if (doorOpen && !OLDdoorOpen)// did the state of doors changed?
    oldMillis = millis();
}

void alarm() {
  if ((millis() - oldMillis > 30000) && doorOpen == true) {
    if (millis() - oldMillisBuzz > 100) {
      oldMillisBuzz =  millis();
      buzzState = !buzzState;
      digitalWrite(buzz, buzzState);
    }
  }
  else
    digitalWrite(buzz, LOW);
}

void allLedBlink() {
  if ((millis() - oldMillisLED > 50) && ON) {
    oldMillisLED =  millis();
    ledState = !ledState;
    digitalWrite(led1, ledState);
    digitalWrite(led2, ledState);
    digitalWrite(led3, ledState);
    digitalWrite(led4, ledState);
  }
 
}
